# Contributing to Micro-Meta App

**This README file gives instructions for testing your code before opening a PR, please ensure you read these.**

1. Fork the GitHub repository.
2. Create a branch for your work based on the main branch. Unless you are targeting a specific release, it is best to work against main.
3. Make your commits, test your changes locally, and open a PR.
4. Make sure you include details of the problem you are fixing and how to test your changes.
5. We may need you to submit some test data. Please contact alex.rigano@umassmed.edu and we will get back to you with secure upload details.

## External Contributors

- PRs submitted from outside contributors will get an initial review to identify if they are suitable. We try to do this as quickly as possible but please be patient if we are busy and it takes longer than expected.
- If there are any obvious issues, we will comment and wait for you to fix them.
- Once we are confident the PR contains no obvious errors, the PR will be included in the merge build jobs for the appropriate branch.
- Build failures will then be noted on the PR and we will provide sufficient information for you to fix the problem yourself before attempting another build.
